#!/usr/bin/python
# -*- coding:utf-8 -*-

import commands
import sys
import os
import os.path
import subprocess
import codecs
import time
import re
#import unicode
import hashlib
#import base64
import solr
import yaml
import sqlite3
confstr="/etc/libre10.conf"
if os.path.exists("./libre10.conf"):
    confstr="./libre10.conf"
elif os.path.exists("../libre10.conf"):
    confstr="../libre10.conf"
conf_dic=yaml.load(open(confstr).read())
sqlpath=conf_dic['dburl']
dbcon=sqlite3.connect(sqlpath,isolation_level=None)
try:
    sql = u"""
create table pdffile (
    id varchar(20),
    path varchar(100),
    page integer,
    title varchar(40),
    title_id varchar(40),
    part integer,
    genre varchar(200),
    startpage integer,
    endpage integer,
    showpagediff integer,
    indexpage integer,
	changed integer
);"""
    dbcon.execute(sql)
except:
    ""
def index_rebuild():
    sql=u"SELECT id,title,part,startpage,endpage,page FROM pdffile"
    cur = dbcon.execute(sql)
    for row in cur:
        print row[1]
        id=row[0]
        title=row[1]
        part=row[2]
        spage=row[3]
        epage=row[4]
        page=row[5]
        bpage=0
        if part >0:
            sql2=u"SELECT title,part,page FROM pdffile WHERE title = ? AND part < ?"
            cur2 = dbcon.execute(sql2,(title,part))
            for row2 in cur2:
                bpage=bpage+row2[2]
        print bpage
        sql3=u"UPDATE pdffile set startpage=?,endpage=? WHERE title = ? AND part = ? AND id = ?"
        cur3 = dbcon.execute(sql3,(bpage,bpage+page,title,part,id))
def PDF2TEXT(pdfpath,dstpath,idnum):
    print pdfpath
    pinfoout=commands.getoutput("pdfinfo \""+pdfpath.encode("utf-8")+"\"")
    pagenum=1
    for sti in pinfoout.split("\n"):
        print sti
        if sti.find("Pages")>-1:
            pagenum=int(sti.replace("Pages","").replace(":","").replace(" ",""))
    s=solr.SolrConnection(conf_dic["solrurl"])
    s.commit()
    if os.path.basename(pdfpath).find("_Part")>-1:
        title_group=os.path.basename(pdfpath).split("_Part")[0]
        print title_group
        parttext=os.path.basename(pdfpath).split("_Part")[1]
        if parttext.find("_")>-1:
            parttext=parttext.split("_")[0]
        print parttext
        if parttext.find(".pdf")>-1:
            parttext=int(parttext.split(".pdf")[0])
        else:
            parttext=int(parttext)
    else:
        parttext=0
        title_group=os.path.basename(pdfpath).split(".pdf")[0]
    print title_group
    print "Part"
    print parttext
    rd = hashlib.md5()
    rd.update(title_group.encode('utf-8'))
    rdl=rd.hexdigest()
    for i in xrange(1,pagenum+1):
        cmd=u"pdftotext -eol unix -enc UTF-8 -f "+str(i)+u" -l "+str(i)+" \""+pdfpath+u"\" page-"+str(i)+dstpath
        p=subprocess.Popen(cmd.encode("utf-8"),shell=True)
        p.wait()
        time.sleep(1)
        TEXT2solr(s,os.path.splitext(os.path.basename(pdfpath))[0],"page-"+str(i)+dstpath,i,pagenum,pdfpath,idnum)
	os.system("rm -f page-"+str(i)+dstpath)
    sql = u"insert into pdffile (id,path,page,title,title_id,part) values (?,?,?,?,?,?)"
    dbcon.execute(sql,(idnum,pdfpath,pagenum,title_group,rdl,parttext))
    s.commit()
def TEXT2solr(solrcon,titletxt,textpath,pagenum,pagemax,pdfpath,idnum):
    f=codecs.open(textpath,"r","utf-8","ignore")
    data1=f.read()
    data1=data1.replace(u"\n",u" ")
    data1=data1.replace(u"<",u"")
    data1=data1.replace(u">",u"")
    data1=data1.replace(u"&","")
    data1=data1.replace('\x0c',u"")
    title_g=titletxt.split("_Part")[0]
    title_g_id=hashlib.sha224(title_g.encode("utf-8")).hexdigest()
    print titletxt+" : "+str(pagenum)+"/"+str(pagemax)
    path_id=idnum
    sql=u"SELECT genre FROM pdffile WHERE title = ? LIMIT 1"
    cur = dbcon.execute(sql,(title_g,))
    genreary=("",)
    for row in cur:
        if row[0] != None:
            genreary=row[0].split(",")
    solrcon.add(id=idnum+"_"+str(pagenum),title=titletxt,title_group=title_g,
    title_group_id=title_g_id,page=int(pagenum),pagemax=int(pagemax),
    text=data1,path_id=path_id,genre=genreary)
argvs=sys.argv
argc=len(argvs)
for st in argvs[1:]:
    #print os.path.splitext(st)
    if os.path.splitext(st)[1].upper() == ".PDF":
        #rd=hashlib.sha224(os.path.splitext(st)[0]).hexdigest()
        #rd2=hashlib.sha224(os.path.abspath(st)).hexdigest()
        #rd = base64.b64encode(os.path.abspath(st))[]
        rd = hashlib.md5()
        rd.update(os.path.abspath(st))
        rdl=rd.hexdigest()
        c = dbcon.cursor()
        c.execute(u"select count(*),changed from pdffile where id=?",(rdl,))
        cfo = c.fetchone()
        filecount = cfo[0]
        if (cfo[1]==None):
            changed=0
        else:
            changed = int(cfo[1])
        
        print st
        print rdl
        print filecount
        if int(filecount)<1 or changed >0:
            PDF2TEXT(st.decode("utf-8"),str(rdl)+".txt",rdl)
            c2 = dbcon.cursor()
            c2.execute(u"UPDATE pdffile SET changed=0 where id=?",(rdl,))
            index_rebuild()
index_rebuild()
dbcon.close()
os.system("chmod -R 777 "+os.path.dirname(sqlpath))
os.system("chmod 777 "+sqlpath)
