#!/usr/bin/perl
use utf8;
use Encode 'decode';
use File::Basename;

#use warnings;
use CGI;

use CGI::Carp qw(fatalsToBrowser);
use DBI;
use DBD::SQLite;

#use Data::Dumper;
use YAML::XS;

#
#   Libre10
#
#   Copyright 2013 yukikaze, long.inus
#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.
#
$cgi = new CGI;
my $confdata = YAML::XS::LoadFile(
	-e 'libre10.conf' ? 'libre10.conf' : '/etc/libre10.conf' );
$pdfpath = decode( 'utf-8', $cgi->param('pdfpath') );
$pdfpath =~ s/\"//g;
$pagenum    = int( $cgi->param('pagenum') );
$pagediff   = int( $cgi->param('pagediff') );
$dpi        = int( $cgi->param('dpi') );
$width      = int( $cgi->param('width') );
$height     = int( $cgi->param('height') );
$mode       = $cgi->param('mode');
$outputpath = "/tmp/libre10/tmp" . generate_unique_key();
$dbpath     = $confdata->{dburl};
$dbi =
  DBI->connect( "dbi:SQLite:dbname=$dbpath", "", "",
	{ RaiseError => 1, AutoCommit => 1 } );
$dbi_state = $dbi->prepare("SELECT path FROM pdffile WHERE id='$pdfpath'");
$dbi_state->execute();

$pdfpath = $dbi_state->fetchrow_array;
$dbi->disconnect;

if ( -e "/tmp/libre10" ) {
}
else {
	system "mkdir /tmp/libre10";
}
if ( ( -e $pdfpath ) && ( -r $pdfpath ) ) {
	$b = $pagenum - $pagediff;
	$e = $pagenum + $pagediff;
	if ( $b < 1 ) {
		$b = 1;
	}
	system "pdfimages -f $pagenum -l $pagenum -j '$pdfpath' $outputpath";
}
$outputpathjpg = "$outputpath-000.jpg";
if ( ( $width > 0 ) or ( $height > 0 ) ) {
	if ( ( $width > 0 ) and !( $height > 0 ) ) {
		$height = 2 * $width;
	}
	if ( !( $width > 0 ) and ( $height > 0 ) ) {
		$width = 2 * $height;
	}

	if ( $width > 0 && $height > 0 ) {
		$outputpath_rs_jpg = "$outputpath-000-$width-$height.jpg";
		generate_resized_image( $outputpathjpg, $outputpath_rs_jpg, $width,
			$height );
		$outputpathjpg = $outputpath_rs_jpg;
	}
}
if ( -e $outputpathjpg ) {
	$size = -s $outputpathjpg;
	print "Content-type: image/jpeg\n";
	print "Content-length:", $size, "\n";
	print "\n";
	open( IN, $outputpathjpg );
	binmode(IN);
	binmode(STDOUT);

	#read(IN,$buf,$size);
	while ( read( IN, $buf, 1048576 ) ) {
		print $buf;
	}
	close(IN);
	system "rm $outputpath-*";

}
else {
	print $cgi->header( -type => "text/html", -charset => "utf-8" );
	print $cgi->start_html( -title => "rec10 pdf search", -lang => "ja-JP" );
	print "error<br>";

	print "pdfimages -f $pagenum -l $pagenum -j '$pdfpath' $outputpath";
}

sub generate_unique_key {
	my $ukey;
	my @str = ( 0 .. 9, 'A' .. 'Z', 'a' .. 'z' );

	foreach ( 1 .. 8 ) {
		$ukey .= $str[ int( rand(@str) ) ];
	}
	return $ukey;
}

sub generate_resized_image {
	my ( $img_path, $resized_img_path, $width, $height ) = @_;
	$size   = "$width" . "x" . "$height";
	$gmpath = `which gm`;
	chomp($gmpath);
	if ( -x $gmpath ) {
		system
"gm convert -quality 80 -size $size -resize $size\\> \"$img_path\" \"$resized_img_path\"";
	}
	else {
		system
"convert -define jpeg:size=$size -quality 60 -thumbnail $size\\> \"$img_path\" \"$resized_img_path\"";
	}
	if ( not -e "$resized_img_path" ) {
		system
"convert -define jpeg:size=$size -quality 60 -thumbnail $size\\> \"$img_path\" \"$resized_img_path\"";
	}
}
